; Double Action Blaster Guys
;
; Copyright (C) 2012-2014 NovaSquirrel
;
; This program is free software: you can redistribute it and/or
; modify it under the terms of the GNU General Public License as
; published by the Free Software Foundation; either version 3 of the
; License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;

.zeropage
r_seed: .res 1
.code

.proc ReadJoy
  lda keydown
  sta keylast
  lda keydown+1
  sta keylast+1
  lda #1
  sta keydown+1
  sta JOY1
  lda #0
  sta JOY1
  : lda JOY1
    and #$03
    cmp #1
    rol keydown+0
    lda JOY2
    and #$03
    cmp #1
    rol keydown+1
    bcc :-
  rts
.endproc
.proc wait_vblank
  lda retraces
  loop:
    cmp retraces
    beq loop
  pha
  lda #0
  sta OAMADDR
  sta OamPtr
  lda #2
  sta OAM_DMA

  lda EnableNMIDraw
  bne :+
    pla
    rts
: dec EnableNMIDraw

  lda #$3f
  sta PPUADDR
  lda #$1e
  sta PPUADDR
  lda FlashColor
  sta PPUDATA
  lda retraces
  and #1
  beq :+
  lda FlashColor
  add #1
  sta FlashColor
  cmp #$2c
  bne :+
    lda #$21
    sta FlashColor
  :

 .repeat 5, I ; change if the max number of tile changes per frame is changed
    lda TileUpdateA1+I
    beq :+
      sta PPUADDR
      lda TileUpdateA2+I
      sta PPUADDR
      lda TileUpdateT+I
      sta PPUDATA
      lda #0
      sta TileUpdateA1+I
    :
 .endrep
 .repeat 4, I ; change if the max number of metatile changes per frame is changed
    lda BlockUpdateA1+I
    beq :+
      sta PPUADDR
      lda BlockUpdateA2+I
      sta PPUADDR
      lda BlockUpdateT1+I
      sta PPUDATA
      lda BlockUpdateT2+I
      sta PPUDATA

      lda BlockUpdateB1+I
      sta PPUADDR
      lda BlockUpdateB2+I
      sta PPUADDR
      lda BlockUpdateT3+I
      sta PPUDATA
      lda BlockUpdateT4+I
      sta PPUDATA
      lda #0
      sta BlockUpdateA1+I
    :
  .endrep

  lda ScrollMode
  jne NoDraw
.if 0
  beq :+
;    lda ScrollGameMode
;    jeq NoDraw
    lda #VBLANK_NMI | NT_2000 | OBJ_8X8 | BG_0000 | OBJ_1000 | VRAM_DOWN
    sta PPUCTRL
    lda Update28Address+0
    sta PPUADDR
    lda Update28Address+1
    sta PPUADDR
    jsr Draw28
    jmp NoDraw
  :
.endif
  PositionXY 0, 2,2
  jsr Draw28

  PositionXY 0, 2,3
  .repeat 11, I
    lda StatusRow2 + I
    sta PPUDATA
  .endrep

NoDraw:
  bit PPUSTATUS
  lda ScrollX+1
  sta PPUSCROLL
  lda #0
  sta PPUSCROLL

  lda #VBLANK_NMI | NT_2000 | OBJ_8X8 | BG_0000 | OBJ_1000
  sta PPUCTRL
  pla
  rts

Draw28:
  .repeat 28, I
    lda StatusRow1 + I
    sta PPUDATA
  .endrep
  rts
.endproc

.proc PutHex
	pha
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hexdigits,x
	sta PPUDATA
	pla
	and #$0f
	tax
	lda hexdigits,x
	sta PPUDATA
	pla
	rts
hexdigits:	.byt "0123456789ABCDEF"
.endproc

.proc PutDecimal ; Prints with anywhere from 1 to 3 digits
   cmp #10 ; only one char
   bcs :+
     add #'0'    ; char is number+'0'
     sta PPUDATA
     rts
   :

   ; the hundreds digit if necessary
   cmp #200
   bcc LessThan200
   ldx #'2'
   stx PPUDATA
   sub #200
   jmp :+
LessThan200:
   cmp #100
   bcc :+
   ldx #'1'
   stx PPUDATA
   sub #100
:
   ldx #'0'    ; now calculate the tens digit
:  cmp #10
   bcc Finish
   sbc #10     ; carry will be set if this runs anyway
   inx
   jmp :-
Finish:
   stx PPUDATA ; display tens digit
   add #'0'
   sta PPUDATA ; display ones digit
   rts
.endproc
.proc ClearName
;Clear the nametable
  ldx #$20
  ldy #$00
  stx PPUADDR
  sty PPUADDR
  ldx #64
  ldy #4
  lda #' '
: sta PPUDATA
  inx
  bne :-
  dey
  bne :-
;Clear the attributes
  ldy #64
  lda #0
: dey
  bne :-
  sta PPUSCROLL
  sta PPUSCROLL
  rts
.endproc

.proc WaitForKey
: jsr ReadJoy
  lda keydown
  ora keydown+1
  beq :-
  lda keylast
  ora keylast+1
  bne :-
  rts
.endproc
.proc PutStringImmediate
	DPL = $02
	DPH = $03
	pla					; Get the low part of "return" address
                        ; (data start address)
	sta     DPL     
	pla 
	sta     DPH         ; Get the high part of "return" address
                        ; (data start address)
						; Note: actually we're pointing one short
PSINB:	ldy #1
	lda (DPL),y         ; Get the next string character
	inc DPL             ; update the pointer
	bne PSICHO          ; if not, we're pointing to next character
	inc DPH             ; account for page crossing
PSICHO:	ora #0          ; Set flags according to contents of 
                        ;    Accumulator
	beq     PSIX1       ; don't print the final NULL 
	sta PPUDATA         ; write it out
	jmp     PSINB       ; back around
PSIX1:	inc     DPL     ; 
	bne     PSIX2       ;
	inc     DPH         ; account for page crossing
PSIX2:	jmp     (DPL)   ; return to byte following final NULL
.endproc
.macro LoadPalette Addr
    lda #0
    sta PPUMASK
	lda #$3F
	sta PPUADDR
	lda #$00
	sta PPUADDR
	ldy #0
:	lda Addr,y
	sta PPUDATA
	iny
	cpy #16
	bne :-

	ldy #0
:	lda Addr,y
	sta PPUDATA
	iny
	cpy #16
	bne :-
.endmacro
.macro LoadNametable Addr
	lda #$20
	sta PPUADDR
	lda #$00
	sta PPUADDR

	lda #<Addr
	sta 0
	lda #>Addr
	sta 1
	ldx #4
	ldy #0
:	lda ($0), y
	sta PPUDATA
	iny
	bne :-
	inc 1
	dex
	bne :-
    lda #0
    sta PPUSCROLL
    sta PPUSCROLL
.endmacro
.proc rand_8    ; From some site
  lda   r_seed  ; get seed
  and   #$B8    ; mask non feedback bits
                ; for maximal length run with 8 bits we need
                ; taps at b7, b5, b4 and b3
  ldx   #$05    ; bit count (shift top 5 bits)
  ldy   #$00    ; clear feedback count
F_loop:
  asl   A       ; shift bit into carry
  bcc   bit_clr ; branch if bit = 0

  iny           ; increment feedback count (b0 is XOR all the	
                ; shifted bits from A)
bit_clr:
  dex           ; decrement count
  bne   F_loop  ; loop if not all done
no_clr:
  tya           ; copy feedback count
  lsr   A       ; bit 0 into Cb
  lda   r_seed  ; get seed back
  rol   A       ; rotate carry into byte
  sta   r_seed  ; save number as next seed
  rts           ; done
.endproc

.proc BitSelect
 .byt %00000001
 .byt %00000010
 .byt %00000100
 .byt %00001000
 .byt %00010000
 .byt %00100000
 .byt %01000000
 .byt %10000000
.endproc
.proc BitCancel
 .byt %11111110
 .byt %11111101
 .byt %11111011
 .byt %11110111
 .byt %11101111
 .byt %11011111
 .byt %10111111
 .byt %01111111
.endproc

.macro neg16 val
  sec             ;Ensure carry is set
  lda #0          ;Load constant zero
  sbc val+0       ;... subtract the least significant byte
  sta val+0       ;... and store the result
  lda #0          ;Load constant zero again
  sbc val+1       ;... subtract the most significant byte
  sta val+1       ;... and store the result
.endmacro

; added stuff
.proc SpeedAngle2Offset ; A = speed, Y = angle -> 0,1(X) 2,3(Y)
Angle = 4
Speed = 5
  sty Angle
  sta Speed

  lda CosineTable,y
  php
  bpl :+
  eor #255
  add #1
: ldy Speed
  jsr mul8
  sty 0
  sta 1

  plp
  bpl :+
  neg16 0
:

  ldy Angle
  lda SineTable,y
  php
  bpl :+
  eor #255
  add #1
: ldy Speed
  jsr mul8
  sty 2
  sta 3
  plp
  bpl :+
  neg16 2
:
  rts
.endproc
